import java.awt.Dimension;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;

import jusecase.ScriptEngine;
import jusecase.components.ScriptedWindow;

public class Basics extends JFrame implements WindowListener
{
    public Basics()
    {
        super("JUseCase Tutorial");

        // To make sure we use our own event handling
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        addWindowListener(this);

        setSize(new Dimension(200, 150));
        setVisible(true);

        // connect the window CLOSING event to JUseCase
        ScriptedWindow.connect("quit", this);

        System.out.println("JUseCase tutorial application started");
    }

    public void windowClosed(WindowEvent e)
    {
        // make sure the last detected event is recorded to file
        ScriptEngine.instance().shutDown();

        System.out.println("JUseCase tutorial application shut down");
    }

    public void windowClosing(WindowEvent e)
    {
        System.out.println("Main window is being closed");
        dispose();
    }

    // from the WindowListener interface, but not used...
    public void windowActivated(WindowEvent e) { /* ignore */}
    public void windowDeactivated(WindowEvent e) { /* ignore */}
    public void windowDeiconified(WindowEvent e) { /* ignore */}
    public void windowIconified(WindowEvent e) { /* ignore */}
    public void windowOpened(WindowEvent e) { /* ignore */}
    

    public static void main(String[] args)
    {
        new Basics();

        // Starts JUseCase replayer if jusecase is configured for replaying
        ScriptEngine.instance().replay();
    }

}
